Bug 444776 - iBFT target info not parsed properly by the iscsi_ibft module
iBFT target info not parsed properly by the iscsi_ibft module
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.3
All Linux
high Severity high
: rc
: ---
Assigned To: Mike Christie
Martin Jenner
: OtherQA
Depends On:
Blocks: KernelPrio5.3
  Show dependency treegraph
 
Reported: 2008-04-30 11:06 EDT by Shyam kumar Iyer
Modified: 2010-10-22 20:37 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-01-20 15:00:31 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Config details. (1.04 KB, text/plain)
2008-04-30 11:08 EDT, Shyam kumar Iyer
no flags Details
Patch to correct eot_offset calculation problem (553 bytes, patch)
2008-06-10 10:59 EDT, Shyam kumar Iyer
no flags Details | Diff
Patch Signed-off-by: Shyam Kumar Iyer <shyam_iyer@dell.com> (608 bytes, patch)
2008-08-18 05:16 EDT, Shyam kumar Iyer
no flags Details | Diff

  None (edit)
Description Shyam kumar Iyer 2008-04-30 11:06:54 EDT
Description of problem:
iBFT info is not parsed properly by the iscsi_ibft module and hence the sysfs 
does not export the target information to the /sys/firmware/ibft directories.
The result of this is that the installer will not be able to connect to the 
iSCSI target automatically.

Version-Release number of selected component (if applicable):
RHEL-5.2-Snapshot-6., Kernel-2.6.18-90.el5
Patch that introduced this bug -
linux-2.6-firmware-ibft_iscsi-prevent-misconfigured-ibfts.patch

How reproducible:
Often.

Steps to Reproduce:
1.Configure the NIC firmware to populate iBFT region with iSCSI target 
information to connect to.
2.Start install of RHEL-5.2-Snapshot6.
3. Hint: Use the target iqn name given in the attachment config detail i.e. 
iqn.1984-05.com.dell:tgt
  
Actual results:
1. The installer does not connect automatically to the target.

Expected results:
1. The installer should connect automatically to the target.

Additional info:
This is is a regression caused by the linux-2.6-firmware-ibft_iscsi-prevent-
misconfigured-ibfts.patch which does not calculate the eot_offset value 
correctly and hence the kobject is not created properly for the target to be 
exported via sysfs.
Comment 1 Shyam kumar Iyer 2008-04-30 11:08:47 EDT
Created attachment 304241 [details]
Config details.
Comment 2 Shyam kumar Iyer 2008-04-30 11:21:37 EDT
Oops. I forgot to go the issue-tracker way. Pardon me for jumping to bugzilla 
here. Creating issue-tracker for this.
Comment 3 Shyam kumar Iyer 2008-04-30 11:27:19 EDT
Issue tracker id 177822 created for this issue.
Comment 5 Mike Christie 2008-06-04 17:15:37 EDT
Does Dell have a patch by any chance.
Comment 6 Mike Christie 2008-06-04 17:17:05 EDT
(In reply to comment #5)
> Does Dell have a patch by any chance.

Do we also have a Dell box for this? Does dell have the iscsi firmware on their
box or is this on a intel or broadcom card? If it is on a nic then we probably
do not need a dell box to replicate and test it here.
Comment 7 Shyam kumar Iyer 2008-06-10 10:56:53 EDT
Mike: 
The issue does not require a Dell box. It just requires a particular iqn name 
format.
The issue is because of an offset calculatation error in the iscsi_ibft.c 
code.  Due to this error directory structure for the target 
in /sys/firmware/ibft does not get created and so the initiator is unable to 
connect to the target.

Note that this bug surfaced only with an name that had a short section at the 
end.
eg: "iqn.1984-05.com.dell:dell".
It did not surface when the iqn's had a longer section at the end.
eg: "iqn.2001-04.com.example:storage.disk2.sys1.xyz"

So, the eot_offset was calculated such that an extra 48 bytes i.e. the size of 
the ibft_header which has already been accounted was subtracted twice.

This was not evident with longer iqn names because they would overshoot the 
total ibft length more than 48 bytes and thus would escape the bug.

Attaching the patch that fixes the issue.
I think upstream needs this fix as well.
Comment 8 Shyam kumar Iyer 2008-06-10 10:59:09 EDT
Created attachment 308821 [details]
Patch to correct eot_offset calculation problem

Patch to correct eot_offset calculation problem.
Comment 9 Mike Christie 2008-06-10 16:50:38 EDT
Thanks for the explanation and patch! Adding devel ack for 5.3.
Comment 11 Shyam kumar Iyer 2008-08-18 05:16:49 EDT
Created attachment 314468 [details]
Patch Signed-off-by: Shyam Kumar Iyer <shyam_iyer@dell.com>
Comment 12 Don Zickus 2008-09-10 16:13:43 EDT
in kernel-2.6.18-110.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5
Comment 13 Shyam kumar Iyer 2008-09-11 07:27:45 EDT
Tested with the test kernel specified in comment#12.

iSCSI boot happened sucessfully with different iqn names including -

iqn.1984-05.com.dell:dell which used to cause the kernel panic earlier.
Comment 17 Chris Ward 2008-11-14 09:03:27 EST
~~~ Attention Partners! ~~~

Please test this URGENT / HIGH priority bug at your earliest convenience to ensure it makes it into the upcoming RHEL 5.3 release. The fix should be present in the Partner Snapshot #2 (kernel*-122), available NOW at ftp://partners.redhat.com. As we are approaching the end of the RHEL 5.3 test cycle, it is critical that you report back testing results as soon as possible. 

If you have VERIFIED the fix, please add PartnerVerified to the Bugzilla Keywords field to indicate this. If you find that this issue has not been properly fixed, set the bug status to ASSIGNED with a comment describing the issues you encountered.

All NEW issues encountered (not part of this bug fix) should have a new bug created with the proper keywords and flags set to trigger a review for their inclusion in the upcoming RHEL 5.3 or other future release. Post a link in this bugzilla pointing to the new issue to ensure it is not overlooked.

For any additional questions, speak with your Partner Manager.
Comment 18 Chris Ward 2008-11-18 13:12:05 EST
~~ Snapshot 3 is now available ~~ 

Snapshot 3 is now available for Partner Testing, which should contain a fix that resolves this bug. ISO's available as usual at ftp://partners.redhat.com. Your testing feedback is vital! Please let us know if you encounter any NEW issues (file a new bug) or if you have VERIFIED the fix is present and functioning as expected (add PartnerVerified Keyword).

Ping your Partner Manager with any additional questions. Thanks!
Comment 19 Chris Ward 2008-11-28 01:44:04 EST
~~ Attention ~~ Snapshot 4 is now available for testing @ partners.redhat.com ~~

Partners, it is vital that we get your testing feedback on this important bug fix / feature request. If you are unable to test, please clearly indicate this in a comment to this bug or directly with your partner manager. If we do not receive your test feedback, this bug is at risk from being dropped from the release.

If you have VERIFIED the fix, please add PartnerVerified to the Bugzilla Keywords field, along with a description of the test results. 

If you encounter a new bug, CLONE this bug and request from your Partner manager to review. We are no longer excepting new bugs into the release, bar critical regressions.
Comment 20 Shyam kumar Iyer 2008-12-02 02:39:06 EST
This issue has been verified to be fixed. The patch is also present. Testing was done with snapshot3 and snapshot4.
Comment 23 errata-xmlrpc 2009-01-20 15:00:31 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-0225.html

Note You need to log in before you can comment on or make changes to this bug.